mob
	Login()
		src.client.perspective = EDGE_PERSPECTIVE
		icon = 'smiley.dmi'
		icon_state = "smiley"
		world<<"[src] logs in!"
		src.loc = locate(1,1,1)
		world<<"This party system allows you to have as many people as you want following you."
		world<<"This party system also asks the leader of a party if they want to allow you to join the party or not."
		world<<"When someone logs out, the party system will not screw up."
		world<<"<u>Functions:</u>"
		world<<" - Party_Message(msg as text) // sends a message to everyone in your party"
		world<<" - Party.Remove(src) // removes someone from the party(built in byond function)"
		world<<" - Party.Add(src) // adds someone to the party(built in byond function)"
		world<<" - Refresh_Party() // refreshes the party(no need to touch this unless adding on to the party system"
		world<<" - Clear_Party_Stats() // makes things seem as though someone was enver in a party(no need to touch this unless adding on to the party system"
		//src<<sound('music.mid',1)
	Logout()
		//Party Check
		if(src.Leader == src)
			if(src.Party.len > 1)
				var/mob/m = src.Party[2]
				m.Leader = m
				src.Party_Message("<b><small>[src] has left the party!")
				m.Party.Remove(src)
				m.Refresh_Party()
				m<<"<b><small>You are now the new party leader!"
				m.density = 1
				for(var/mob/p in m.Party)if(p != m)p<<"<b><small>[m] is the new party leader!"
				m.verbs += typesof(/mob/Party_Leader/verb)
				m.verbs -= typesof(/mob/In_Party/verb)
			src.Clear_Party_Stats()
		else if(src.Party.len > 1 && src.Leader != src)
			src.Party_Message("<b><small>[src] has left the party!")
			for(var/mob/m in src.Party)if(m.Leader == m)
				m.Party.Remove(src)
				m.Refresh_Party()
				break
			src.Clear_Party_Stats()
		//Other
		world<<"[src] logs out!"
		del(src)

turf
	icon = 'smiley.dmi'
	icon_state = "grass"

mob/verb/Who()
	src<<"<b><small><u>People online:"
	var/players = 0
	for(var/mob/m in world)if(m.client)
		players++
		src<<" - <b><small>[m]([m.key])"
	src<<"<b><small>People online: [players]"

mob/var
	spam=0
	mute=0

mob/verb/say(msg as text)
	set hidden = 1
	if(msg&&src.spam<=3&&src.mute==0)
		world<<"<font color = black><b>[src]</b>: [html_encode(copytext(check(msg),1,501))]"
		src.spam++
		spawn(8)src.spam--
		if(spam>3)
			world<<"<small><b>[src] has been temporarely(1 minute) muted for spamming!"
			src.mute=1
			spawn(600)src.mute=0

client/command_text={"say ""}

proc/check(msg as text)
	var/search = list("\n")
	for(var/c in search)
		var/pos = findText(msg,c)
		while(pos)
			msg = "[copytext(msg,1,pos)]\\n[copytext(msg,pos+1)]"
			pos = findText(msg,c,pos)
	return msg